<template>
    <div class="content-block" ref="root">
        <div class="container">
            <div class="pos-container" :class="$interface.viewport" v-if="ready">
                <!-- шапка со статусом займов -->
                <div class="header">
                    <h1>Целевое кредитование</h1>
                    <pos-status></pos-status>
                </div>

                <div class="payment-info">
                    <payment-info-header></payment-info-header>
                </div>

                <template v-if="!$route.params.page">
                    <!-- информация об оплате -->
                    <div class="loan-details" :class="{'no-active': !$POS.schedule.length}">
                        <loan-details></loan-details>
<!--                        <loan-details-extends></loan-details-extends>-->
                    </div>

                    <div class="loan-schedule">
                        <loan-schedule></loan-schedule>
                    </div>

                    <div class="operations-list">
                        <operations-list :list="operations"></operations-list>
                    </div>
                </template>

                <template v-if="$route.params.page === 'payment'">
                    <pos-payment :create-handler="payFormCreateHandler"
                                @back="$router.push({name: 'pos'})"
                    ></pos-payment>
                </template>
            </div>


        </div>
    </div>
</template>

<script>
    import {mapGetters} from 'vuex';
    import PosStatus from './components/pos-status';
    import OperationsList from './components/operations-list';
    import PaymentInfoHeader from './components/payment-info-header';
    import LoanDetails from './components/loan-details';
    import LoanDetailsExtends from './components/loan-details-extends';
    import LoanSchedule from './components/loan-schedule';
    import PosPayment from '@/components/PayForm';

	export default {

		name: 'pages-pos',
        components: {
        	PosStatus,
            OperationsList,
            PaymentInfoHeader,
            LoanDetails,
            LoanDetailsExtends,
			LoanSchedule,
            PosPayment,
        },

        computed: {
        	...mapGetters(['$POS']),
            operations () {
				const data = [].concat(this.$POS.operations, this.$POS.rejections, this.$POS.transactions);
				return data.sort((a, b) => {
					return new Date(a.date).getTime() - new Date(b.date).getTime();
				})
			}
        },

        data () {
        	return {
        		ready: false,
            }
        },


        created () {
            this.loadPosData();
        },

        mounted () {

        },

        beforeDestroy () {
		    this.$store.commit('PAYMENT_SET_ORDER', []);
        },

        methods: {
        	loadPosData () {
        		this.AJAX_LOADING({
                    waitingTitle: 'Загрузка'
                });

        		const promises = [];
        		promises.push(this.$store.dispatch('POS_GET_SCHEDULE'));
        		promises.push(this.$store.dispatch('POS_GET_OPERATIONS'));
        		promises.push(this.$store.dispatch('POS_GET_REJECTIONS'));
        		promises.push(this.$store.dispatch('POS_GET_TRANSACTIONS'));

        		Promise.all(promises).finally(() => {
                	this.AJAX_LOADING(false);
					this.ready = true;
					this.$nextTick(() => {
					    this.$helpers.scroll(this.$refs.root);
                    })
				})
            },

            payFormCreateHandler () {
                this.$store.commit('SET_PAYMENT', {
                    type: 'POS',
                    amount: this.$POS.debt + this.$POS.currentPaySum
                });

                this.$store.commit('PAYMENT_SET_ORDER', this.$POS.currentPayNumbers.map((id) => {
                    return { number: id, type: 5 }
                }));
                console.log('payFormCreateHandler');
            }
        }
	};
</script>
